{ File    : $URL: file:///D:/SVN/svnDelphi/trunk/BS5/VT7AExt/src/utils/ModInfo.pas $
  Author  : $Author: Deniz Oezmen $
  Changed : $Date: 2013-12-07 10:36:56 +0100 (Sa, 07 Dez 2013) $
  Revision: $Rev: 215 $
}
unit ModInfo;

interface

function GetModuleFileVersionString: AnsiString;

implementation

uses
  SysUtils, Windows;

function GetFileVersionString(const FileName: AnsiString): AnsiString;
var
  Handle      : THandle;
  InfoSize    : Longword;
  FileInfo    : Pointer;
  Size        : Longword;
  Translation,
  Value       : Pointer;
  InternalName,
  FileVersion : AnsiString;
begin
  Result := '';

  InfoSize := GetFileVersionInfoSize(PChar(FileName), Handle);
  if InfoSize > 0 then
    FileInfo := GetMemory(InfoSize)
  else
    FileInfo := nil;

  if Assigned(FileInfo) then
  begin
    if GetFileVersionInfo(PChar(FileName), Handle, InfoSize, FileInfo) then
    begin
      if VerQueryValue(FileInfo, '\VarFileInfo\Translation', Translation,
        Size) then
      begin
        if VerQueryValue(FileInfo,
          PChar(Format('\StringFileInfo\%.4x%.4x\InternalName',
          [LoWord(Longword(Translation^)), HiWord(Longword(Translation^))])),
          Value, Size) then
            InternalName := string(PChar(Value));

        if VerQueryValue(FileInfo,
          PChar(Format('\StringFileInfo\%.4x%.4x\FileVersion',
          [LoWord(Longword(Translation^)), HiWord(Longword(Translation^))])),
          Value, Size) then
            FileVersion := string(PChar(Value))
      end
    end;

    FreeMemory(FileInfo)
  end;

  Result := Trim(Format('%s %s', [InternalName, FileVersion]))
end;

function GetModuleFileVersionString: string;
var
  FileName: array[0..MAX_PATH] of Char;
begin
  GetModuleFileName(0, FileName, MAX_PATH);

  Result := GetFileVersionString(FileName)
end;

end.
